package digital.laboratory.platform.reagent.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import digital.laboratory.platform.reagent.entity.CategoryTable;
import digital.laboratory.platform.reagent.mapper.CategoryTableMapper;
import digital.laboratory.platform.reagent.service.CategoryTableService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 服务实现类
 *
 * @author Zhang Xiaolong created at  2023-03-29
 * @describe 服务实现类
 */
@Service
@SuppressWarnings("all")
public class CategoryTableServiceImpl extends ServiceImpl<CategoryTableMapper, CategoryTable> implements CategoryTableService {
    @Override
    public CategoryTable addSpecies(String category, String species) {

        CategoryTable oldCategoryTable = this.getOne(Wrappers.<CategoryTable>lambdaQuery().eq(CategoryTable::getCategory, category).eq(CategoryTable::getSpecies, species));

        if (oldCategoryTable == null) {
            CategoryTable categoryTable = new CategoryTable();
            categoryTable.setId(IdWorker.get32UUID().toUpperCase());
            categoryTable.setSpecies(species);
            categoryTable.setCategory(category);
            this.save(categoryTable);
            return categoryTable;
        }
        return oldCategoryTable;
    }

    @Override
    public Boolean delSpeciesById(String categoryTableId) {

        CategoryTable byId = this.getById(categoryTableId);

        return this.removeById(byId);
    }

    @Override
    public List<CategoryTable> getSpecies(String category) {
        return this.list(Wrappers.<CategoryTable>lambdaQuery().eq(CategoryTable::getCategory, category));
    }

}
